# alphabet_traits< S, T > Struct Template Reference
[Alphabet]

Trait for virtual types of structural elements for alphabets. More...

List of all members.

## Public Types

typedef undefined_type | letter_t
| The type of letters in any alphabet.
typedef undefined_type | first_projection_t
| Whether the alphabet has a first projection computable.
typedef undefined_type | second_projection_t
| Whether the alphabet has a second projection computable.

## Static Public Attributes

static const bool | dynamic_data = false
| Whether an alphabet contains dynamic data.

## Detailed Description

### template<typename S, typename T>
struct vcsn::algebra::alphabet_traits< S, T >

Trait for virtual types of structural elements for alphabets.

Contains a definition of `letter_t`, the type of any letter in an alphabet. It should be specialized for all derived structures.

Definition at line 77 of file alphabets_base.hh.